#PayFrost Secret Management System Whitepaper
<br>
##Introduction
The technology described in this whitepaper describes the design and rationale of the technology featured in both PayFrost's cryptocurrency insurance system and password manager.
<br>
##Design Goals

###Shared Design Goals
Both our cryptocurrency insurance system and password manager share the following design goals:

1.  The system must be able to recover from loss of account credentials.

	Statistically, 20% of all Bitcoin ever mined has become inaccessible to the public since the last owner lost access to their private key. Often, the medium storage housing the private key was lost from the owner or the owner forgot the password used to decrypt the private key. This is a huge statistic, and no cryptocurrency insurance system that does not have a solution to this will survive.
	
	Today, most password managers are designed to be decrypted using the user's password. If the user forgets this password for any reason, the user is unable to use their password manager account and must make a new one.
	
2. The system must be able to recover from theft of account credentials.

	Several billions of dollars worth of cryptocurrency has been reported to be stolen from unsuspecting users by 2021. Often, cryptocurrency users store their cryptocurrency without using strong multi-factor authentication. This is the same reason why users of password managers often fall prey to phishing or keylogging attacks that steal the user's master password.
	
3. The system must be inexpensive to maintain--both in terms of time and money.

	Without this important feature, most users will deem the system to be expensive to maintain. In the United States, a person is guranteed to be insured $250,000 USD by the federal government in the event that any disaster causes the user to lose money. If a user spends about $4000 USD in BTC over the span of five months, it would be wise to not make an insurance premium more than $5 per month, or ~0.625% per BTC transaction per month.
	
	A password manager premium may be even cheaper since it does not require a transaction fee and most of the technology to maintain a password manager is simply executing software.
	
4. The system must be simple for developers to understand and therefore implement.

Many modern cryptosystems suffer from a very intricate design. Often, developers thus accidentially implement them incorrectly. Later, users that use the faulty cryptosystem become victims of data compromise. The design and programming libraries used in this system was intended to be simple for the average developer with an undergraduate college education to understand and implement.
<br>	
###Cryptocurrency Insurance Design Goals

The following design goal is unique to cryptocurrency insurance.

1. The insurance system must be able to pass on user's funds to the user's family following the user's death.
<br>
##Threat Model

Standard login systems take place on three major user interfaces:

1. Web Browser

2. Mobile Application

3. Desktop Application

The difference in how the user downloads the source code in each of the above three cases determines how suspectible each interface is to theft of account credentials relative to the others.

 Web browsers are most likely to be suspectible to theft of user password. Since web browsers rely on the integrity of the server they are connected to, a malicious server can intentionally send source code to the user designed to make the website look authentic but that actually steals the user's password. And the user will most likely not realize this until it is too late. Considering how convenient web browsing is and how easy it is to send malicious code to users, web browsers are easily the most dangerous target.
 
 Mobile applications are the second most suspectible target to theft of account credentials. The most efficient way for an attacker to steal user credentials is to trick a user into downloading a malicious app from a website. In the real world, most users will most likely visit the application store of their mobile operating system, search for the app, and download the app from the online application store. Since the online application store has a review system, the user is most likely to download the true app. This is not the only way the user's mobile passwords can get stolen. The attacker can also feed the user a malicious link by email, SMS, or social media. Once the user clicks on the link, a keylogger malware may download to the user's mobile phone and send everything the user types to the attacker. Mobile phones are more frequently used by people than desktop or even laptop devices. Automatically making this the second most dangerous target.
 
 The final and least suspectible of these interfaces is the desktop application. Fewer users are willing to go through the trouble of launching a desktop application from their laptop or desktop than they are willing to use a web browser or mobile device. The reason is understandable: a desktop or laptop is heavier to carry around than a mobile device. This is why most attackers have the least incentive to send a phishing link of any kind to a user in the hopes they will try to download a desktop application.
 
 Finally, a common flaw of all zero-knowledge encryption systems is that they have a single point of failure. If a user's password is stolen, often by social engineering, the user's account is compromised. In reality, most users simply forget what their passwords were or lose access to the encrypted data in the first place. It is wiser to have tolerance for multiple points of failure without compromising the security of the system.
 
###STRIDE Threat Model
 
 A more professional analysis of the threats can compromise the security of the user under the PayFrost Secret Management System can be performed under the STRIDE Threat Model Framework. Under the STRIDE Threat Model Framework, all possible threats are classified under the six following:
 
 1. Spoofing
 2. Tampering
 3. Repudiation
 4. Information Disclosure
 5. Denial of Service
 6. Elevation of Privilege
 
####Spoofing

Spoofing takes place whenever an attacker successfully impersonates the user. In the PayFrost Secret Management System, this can technically happen if the attacker steals both the user's and mobile's client password. To do this, the attacker must trick the user into sending their client password on a phishing web site or desktop application *and* trick the user into typing their mobile password on a phishing mobile app the user downloaded. An optional additional protection is that the user may additionally require a successful U2F challenge response on the client application. This would be a sound precaution if the user expects to frequently visit the PayFrost website on a web browser instead of the desktop application since users as this is more suspectible to phishing. If a victim lands on a phishing site and the user is required to pass a U2F test, the PayFrost server will detect that the user has landed on a phishing site when it realizes the U2F challenge response is under a distinct domain and will even send a warning to the user's mobile application as to when the incident was detected. The user may then change their client password quickly. This will prevent the attacker's phishing attempts from being successful.


####Tampering

All entries recorded in PayFrost database systems are cryptographically signed by both the user and the PayFrost server using a private key managed by a hardware security module. PayFrost will automatically backup all user data on a seperate server protected by distinct authentication and encryption secrets. Therefore, if any adversary attempts to modify either the contents or signatures of users' contents, this will be detected independently by the user and the PayFrost server each. PayFrost will then initiate the data recovery process on behalf of the user. To bypass this anti-tampering system, the adversary must steal the user's secrets (see "Spoofing" above) *and* steal the private key directly from the hardware security module PayFrost is using to make cryptographic digital signatures.

####Repudiation

Repudiation means any person incorrectly denies having performed an activity--whether honestly or with ill-intent. PayFrost will apply the same cryptographic digital signature system in documenting its activity logs in the same way it protects its users' data from tampering. So the threats that can cause successful tampering to go unnoticed apply to Repudiation as well.

####Information Disclosure

Information Disclosure takes place whenever an adversary successfully steals the user's data in its original, unencrypted form. This can take place by downloading malware on the victim's computer that steals the user's data directly while it is an unencrypted state. To prevent this, PayFrost will never ask for users' emails nor phone numbers. These are two insecure mediums of communication that continue to exploited by social engineers to compromise online accounts. The adversary may attempt to steal the password the user enters on the application, whether it be the mobile application or the client application. The adversary may also attempt to steal the symmetric key that is stored in primary memory while the user is in session. This is less risky than stealing the user's password since the attacker must successfully steal the symmetric key on the user's mobile application,  the symmetric key on the user's client application, and the symmetric key managed by the PayFrost server. If the server manages the server symmetric key in a hardware security module it is unfeasible to steal the symmetric key from the server. If the server does not have access to a symmetric key, the server can apply LibSodium's guarded memory allocation functions to read/write protect sensitive information such as the symmetric key within a coroutine specific to the user's session. If any attempts to read/write such information are made, the coroutine will crash and the incident will be recorded in PayFrost's logs. To prevent adversaries from stealing data in-transit from users' devices to the PayFrost server, PayFrost will enforce Strict Transport Layer Security. 

####Denial of Service

Denial of Service takes place in any case where the attacker forcibly prevents users from using their account. One common way attackers do this is by overwhelming servers with a flood of requests--causing servers to crash. To prevent this, the PayFrost online service will apply load balancers to prevent this from being a problem. Additionally, adversaries may deliberately try to delete all user data. PayFrost will backup user data on a separate server to allow for recovery in case this happens. Backups are managed by using the API services that are accompanied with the VPS services PayFrost uses to host their service. To safeguard all API keys, PayFrost manages these API keys using a hardware security module. The API call is made directly inside the hardware security module to ensure the integrity and authenticity of the API call.

####Elevation of Privilege

This threat takes place when an adversary gains more permissions to open, read, rewrite, and delete data than what is normally allowed. This threat is relevant for organizations that use the PayFrost system to share secrets amongst members, where certain members have less privileges and are subordinates to others. In the PayFrost system, the true threat is if the account of a member that is responsible for managing subordinates is compromised (See "Spoofing" above). Members that are responsible for managing subordinates are thus strongly encouraged to choose the most secure options to secure their accounts (See "Information Disclosure" Above).

##Design

###Shamir Secret Sharing

In our system, **Shamir Secret Sharing** will be used to help meet all aforementioned design goals. Shamir Secret Sharing is desirable in our case for the following reasons:

1. It allows the user to safely split any secret into a desired number of pieces, and require the user to use a fixed threshold of **any** of these pieces. If an attacker does not have a threshold number of these pieces, the attacker will be unable to crack the secret from the pieces the attacker has, regardless of the amount of computational power and time the attacker has. This unique property of Shamir Secret Sharing, known as **information-theoretic privacy**, holds true even if the attacker has access to a powerful quantum supercomputer.
<br>
2. If the user loses less than the threshold number of pieces in such a way that they will not get stolen anytime in the near future, the user can quickly replace the lost pieces.
<br>
3. If an attacker manages to steal less than the threshold number of pieces, the threshold number required is fixed, and the user realizes this before the attacker succeeds in stealing the threshold number, the user can replace all Shamir pieces in such a way that would automatically render the user's stolen pieces worthless to the attacker.
<br>
##Login System

Unlike other login systems, our system will require the user to use two distinct passwords at login and a third only when the user lacks simpler alternatives for account recovery. Aside from the obvious downside of having to remember three passwords, the true advantage of passwords is that they are the cheapest authentication method for users to maintain and are perhaps the only true authentication method that cannot be stolen from the user upon the user's death, only cracked if and only if feasible. To help users design a strong and simple to remember password, users' passwords will be screened by the password strength meter "**ZXCVBN**" published by Dropbox for public use. A simple passphrase of four, unrelated words suffices as a standalone password that can survive many years of non-stop attempts to crack, especially when applied to a strong password hashing algorithm. PayFrost will use **Argon2ID** since it limits the attacker's speed down to the physical speed of Random Access Memory.

###Account Creation

####Client-Side Hashing
At the beginning of account creation, the user enters our company website, **payfrost.com** and registers their username and their **browser password**. The user's username is immediately appended to the user's browser password as a cryptographic *pepper* and this password-pepper combination is then hashed using the Argon2ID password hashing algorithm. PayFrost uses the **LibSodium** cryptographic library for all cryptographic operations. Argon2ID allows the developer to set the number of iterations and the quantity of RAM that Argon2ID will use to calculate the hash. PayFrost will use the *crypto_pwhash_OPSLIMIT_INTERACTIVE* parameter from LibSodium to set the number of iterations Argon2ID will perform. PayFrost will also use *crypto_pwhash_MEMLIMIT_INTERACTIVE* from Libsodium to set the amount of RAM Argon2ID will use to calculate the final password hash. Once the final password hash is calculated, this final password hash is applied to a single iteration of the BLAKE2b hash with the master password serving as the salt. This final BLAKE2b hash output is what is sent to the PayFrost server for client password verification. The BLAKE2b hash of the username is additionally sent to the server along with the final BLAKE2b hash output. The hash of the username is stored on the database. Thirdly, a BLAKE2b-based HMAC of this verification hash is sent to the server. The verification hash is also applied to a BLAKE2b-based HMAC whose symmetric key is safely stored on the server. Requiring these two HMAC signatures protects the password verification database from tampering by an adversary.

####Verifying Passwords

Unlike the verification hash and its HMAC outputs, the final BLAKE2b hash output of the password hash is once again hashed with BLAKE2b once more and this final BLAKE2b hash is what is stored on the password verification database. This prevents an attacker from being able to authenticate as the user even if the attacker managed to steal the password verification database. Since the attacker only has the double BLAKE2b hash of the original Argon2ID password hash, merely sending the double BLAKE2b hash will only cause it to get hashed once more--and result in a failed verification hash match on the server. All password hash databases should be designed with the expectation that an adversary will one day gain access to them. It is thus important that verification of user passwords takes place without requiring the server to even receive any of the user's actual secrets.

####Generating Symmetric Keys for Encryption

Once the verification hashes of the user's browser and mobile passwords are recorded on PayFrost's database system, the secret management system will begin generating three, distinct symmetric keys that are used to decrypt user secrets. There are three symmetric secrets involved in every decryption. Each of the three always exists in the RAM of the device and never at rest in any secondary storage drive. All three symmetric keys are 32 bytes, or 256 bits, in size. Each symmetric key is randomly generated using Libsodium's **randombytes_buf** function. The browser application, the mobile application, and the server application will each independently generate its own symmetric key using this technique. Once an application has generated its symmetric secret, it will split the secret into five parts using Shamir Secret Sharing.

####Splitting A Symmetric Key Using Shamir Secret Sharing

In PayFrost's scheme with Shamir's Secret Sharing, each of the three symmetric keys will be split into five pieces. To reconstruct a symmetric key, **three-out-of-five** pieces will be required. Out of those five, two pieces will be set aside to be printed and stored by the user offline and **not** on any computer. Shamir Secret Sharing recommends that just less than the threshold number of pieces are stored elsewhere while the majority of the pieces are still required to reconstruct the secret. In the original whitepaper for Shamir Secret Sharing, this means that the total number of pieces is equal to twice the number of threshold pieces required minus one piece, or *n = 2k-1*, where *n* is the total number of pieces and *k* is the threshold number of pieces. 

Each Shamir piece **must** contain the following information:

1. An x-coordinate used in the calculation of the y-coordinate.
2. The y-coordinate.
3. The prime number used in the calculation. PayFrost will use the Mersenne prime number: $$ 2^{521}-1 $$

The exact equation used in PayFrost's system to derive Shamir Secret Sharing pieces in a 3-out-of-5 scheme is:

$$ y = \big( a_0 + a_1 x + a_2 x^{2} \big) \hspace{1em}mod\hspace{1em} p$$

The `mod` operator in the equation denotes that **Finite Field Arithmetic** must be used to perform the polynomial field interpolation. [Programming Bitcoin: Learn How to Program Bitcoin from Scratch]

This is the equation necessary to generate a three-out-of-five piece threshold in Shamir Secret Sharing.

####Sharing of Shamir Secret Sharing Pieces

#####Cross-Platform Sharing of Pieces

After each application generates two pieces for offline printing, each application will then focus on securely dispersing one other piece each to one of the other two applications. This means the browser application will send one piece to the server directly. The browser's piece is meant to be stored on the server. To send pieces like these securely in-transit, the browser, mobile application, and server will always communicate through **HTTP Strict Transport Layer Security**. The server responds by sending two of its own Shamir pieces that it has reserved for offline printing to the browser. The server will send a signal to both the browser and mobile applications that the server piece sent by the browser has been received. Next, the browser will generate an ephemeral private-public keypair using LibSodium's "Sealed Box" API functions, which are **crypto_box_seal** and **crypto_box_seal_open**, respectively. The browser will send the **public key** to the server. The server will respond to the browser by sending three of its own pieces to the browser--where two of those pieces are reserved for offline printing. The server will send one of its own pieces to the mobile application. Upon receiving the server's piece, the mobile application will send one of its own pieces to the server. This piece is meant to be managed by the server's symmetric key and not the browser's. The mobile application will encrypt another **three** of its own pieces with the browser's public key and send it to the server. The mobile application will then proceed to generate its own ephemeral private-public keypair and send the mobile public key to the server. The browser will detect this, download the three encrypted mobile pieces and the mobile public key, and decrypt the encrypted mobile pieces with the browser's ephemeral private key. One of the mobile pieces the browser has received is meant to be managed by the browser's symmetric key. The other two mobile pieces the browser received are meant to reserved for offline printing. The browser will send a notification to the server that this event was successful, and the server will forward this notification to the mobile application. The browser will encrypt one of its own pieces using the mobile application's public key and send this encrypted piece to the server. The mobile application will fetch this encrypted piece from the server and decrypt it using the mobile application's ephemeral private key. This is a secure method of transporting the browser's piece to the mobile application through with the help of the server application--and vice versa. The server application will not be able to learn what the browser piece was while routing the browser's piece to the mobile application using this ephemeral private-public keypair setup. And the server will also not be able to learn what the mobile piece was while routing the mobile piece to the browser. The browser now possesses three of its own Shamir pieces--two of which must be set aside for printing. The browser also possesses three of the five Shamir pieces belonging to the mobile application--two of which must be set aside for printing. Finally, the browser possesses three of the five Shamir pieces belonging to the server application--two of which must be set aside for printing. The browser will store one of its own pieces, one of the mobile pieces, and one of the server pieces in one document. This document will be stored in RAM for the time being. The other two pieces for the browser, mobile,  and server each are reserved for later offline printing and are also stored in the browser's RAM for the time being.

#####Encrypting The Shamir Pieces on the Server Application

The server application has three pieces. One piece is the server's, another is the browser's, and the third is the mobile's piece. Encrypting the server application's Shamir piece is a unique situation since storing the key to decrypt the server's encrypted document must be computer-automated. Not all developers will have access to a professional hardware security module that is FIPS-140-2 (or FIPS-140-3) compliant and they are expensive to maintain. The server will store the browser piece it was given and the mobile piece it was given in a document and encrypt it using the server's 256-bit symmetric key. Like all encrypted documents, the server encrypts using XChaCha20-Poly1305 and the final encrypted document is applied to HMAC-BLAKE2b where the KDF output derived from the server's symmetric key is used as the HMAC key. The server's last piece will be stored on the server directly in its original form. PayFrost will use the free and open source version of Hashicorp Vault to manage the database storing this server piece. The browser and mobile applications will each incorporate their piece of the server symmmetric key secret into their document. Now both the browser and the mobile application have in their document one Shamir piece of the server symmetric key, one Shamir piece of the mobile symmetric key, and one Shamir piece of the client symmetric key.

It is best if the server has access to a hardware security module. In this case, the Shamir piece should directly be stored by the hardware security module and when reconstruction of the server secret needs to take place, the entire process of reconstruction takes place inside the Hardware Security Module directly and all decryptions or encryptions that rely on the server symmetric secret.

A second copy of the encrypted document that is meant to be decrypted by the server should be made. This version of the encrypted document should be encrypted from a KDF output derived from a third recovery password that is distinct and separate from the browser and mobile application passwords. This will help the user recover their account in case the user loses access to two pieces. In such a situation, the user decrypts or uploads the remaining pieces and also decrypts this version of the server encrypted document with the recovery password.

#####Encrypting The Shamir Pieces on the Mobile Application

The mobile application now has one of its own pieces, one of the browser's pieces, and one of the server's pieces. The mobile application puts these pieces into a document and encrypts it in the same manner as the browser application has--except the key the mobile application uses is the KDF output (512 bits in length) derived from the Argon2ID peppered hash of the user's mobile password (256 bits in length). This KDF output is the symmetric key used with XChaCha20-Poly1305. All encrypted documents, including the browser's, are hashed with HMAC-Blake2b using LibSodium's **crypto_generichash(hash,sizeof hash,MESSAGE,MESSAGE_LEN,key,sizeof key)** function. The mobile application sends the encrypted document to the server to be stored in persistent memory.

#####Encrypting The Shamir Pieces on the Browser Application

The browser will take the Argon2ID hash (256 bits in length) of the user's browser password and stretch it using LibSodium's **crypto_kdf_derive_from_key** function to be 512 bits in length. This KDF output is used by the browser application to encrypt the document containing the browser's piece, mobile piece, and the server piece. All encrypted documents are encrypted using **XChaCha20-Poly1305** and then hashed with HMAC-BLAKE2b using LibSodium's **crypto_generichash(hash,sizeof hash,MESSAGE,MESSAGE_LEN,key,sizeof key)** function. The **key** is the KDF output derived from the Argon2ID peppered password hash of the user's browser password. The mobile application will follow the same procedure to encrypt its document using the KDF output of the Argon2ID hash of the user's salted mobile password.

The server stores the encrypted documents with the assistance of Hashicorp Vault in a database. The user must then print the two offline documents and store each in a separate secure place. Ideally each offline document should be placed in a safe protected by a password.

###Account Login For First Time

When typing in the browser password, the user may choose to visit our website directly, or preferably, use our browser
extension to complete the browser username and password challenge. Once the user completes this challenge, the user's browser extension reconstructs the browser's symmetric key secret and securely stores in session until the user's browser extension session expires. The user may choose how long this session in the browser extension lasts--hence its comparative advantage compared to visiting our website directly. When visiting our website directly and not the browser extension, once the user closes the tab or visits a website with a different origin, the user's session from the website ends. Instead, when the user decides to use our browser extensin, the user has the freedom to choose how long a session lasts--anywhere from 1 minute to as long as 30 days. Once any of the user's sessions expire, including the browser extension's, the symmetric key stored in that application is securely wiped from RAM. Once PayFrost's server verifies the user's username and password combination from either the website or browser extension, it will ask the user to complete the mobile password challenge on our mobile phone application. Once the user completes the mobile application challenge, the mobile application will store the mobile symmetric secret securly in RAM storage until the mobile session expires. This can be anywhere from 1 minute to as much as 30 days. Once the server detects the user passed both the client and mobile challenge, the server will proceed to unlock the user's secrets vault or generate a new one if this is the first time the user is logging in.

Upon the first time logging in, a new vault is generated and the user may proceed to visit a website and log in as normal. If the user is using our browser extension, the browser extension can immediately learn what HTML5 fields correspond to what written content the user expects as the user fills in information and save this data. A new symmetric secret used to encrypt all data for a given origin is randomly generated on the browser extension. First, the browser extension encrypts this symmetric secret with the browser's symmetric key. Then, the browser generates an ephemeral private-public keypair, sends it to the server, and sends a signal to the server asking the server to notify the mobile application to do the same. Upon receiving this signal from the server, the mobile application generates its own ephemeral private-public keypair and sends the public key to the server, which the browser receives. The browser encrypts the encrypted symmmetric secret tied to the given origin with the mobile application's public key and sends it to the server. The mobile application receives this from the server and decrypts the browser's message with its private key. The mobile application then encrypts the browser-encrypted symmetric secret for a given origin with the mobile application's symmetric key. The mobile application finally sends the symmetric secret, now encrypted first with the browser's symmetric key and then the mobile symmetric key on top of that, to the server. For a server that does not have a hardware security module, the server immediately encrypts the symmetric secret for the given domain with the server's symmetric secret. For a server that does not have a hardware security module, the server symmetric secret is stored in RAM while the user is in session. This is not critical for security since the server's symmetric key-based encryption is the outermost layer of decryption. Once this is done, the symmetric secret for the given origin, now encrypted first by browser's symmetric key and second with mobile application's symmetric key and finally by server's symmetric key, is stored on the server in persistent memory with the assistance of Hashicorp Vault. This process repeats for all instances where the user records a new login for any and all accounts while using PayFrost's Secret Management Service.

###Account Login After First Time

After the first time a user fills an account in PayFrost's Secret Management Service, the user can set their browser extension to autofill. This means that the moment the user's browser lands on the login page, the browser extension will cause the login credentials to automatically be filled on behalf of the user. The following describes how decryption of the symmetric secret for a given origin takes place.

First, the user must already have an active session. The user's browser (including browser extension) and mobile phone must both have an active Internet connection. The user must already be logged into the browser extension and the mobile phone application both at the same time. Bear in mind the user has the option to stay logged into both for as long as 30 days within a single session. So when the user lands on the login page, the browser extension, the server, and the mobile application each are already currently storing their respective symmetric key securely in RAM for the time being. The server first acts by decrypting the symmetric secret for the given origin using the server's symmetric key. Next, the browser sends the symmetric secret for the given origin, now encrypted by the mobile's symmetric key and finally the browser symmetric key at the lowest layer of encryption, to the mobile application. The mobile application decrypts the mobile encrypted layer and sends a notification to the server to receive the browser's public key. The browser (or browser extension) quickly generates an ephemeral private-public keypair and sends the browser public key to the server. The mobile application receives the browser's public key and encrypts the symmetric secret for the given origin, now only encrypted by the browser symmetric key, with the browser public key and sends this to the server. The browser receives notification of this, downloads the ephemeral-encrypted symmetric secret for the given orign, decrypts it with the browser private key, and then finally decrypts the symmetric secret for the given origin with the browser symmetric secret--deriving the raw symmetric secret for the given origin necessary to decrypt all content associated with that origin.

####Account Login After First Time for User Experience

For the best user experience when only having access to a mobile device, it is strongly recommended that the user use the Firefox mobile browser application. The Firefox mobile browser application has direct support for all native Firefox browser add-ons. Chromium-based browsers do not have this feature yet at the time of this writing.

###Account Recovery

####Shamir Document Replacement

If a user forgets either their mobile or browser password, the user must first login to the other application whose password they rememeber. Next, the user may select the option to reset the password for the application whose password the user has forgotten. The application will then prompt the user to upload the QR code for one of the printed offline documents. This will allow the PayFrost system to derive the symmetric keys for the server application, mobile application, and browser application each. Using Shamir Secret Sharing, the PayFrost system will generate a new offline QR code piece for the user to print. The PayFrost system will then replace the Shamir encrypted document encrypted by the password the user has forgotten with a brand new one. So the user will replace their password on the application whose password was forgotten. The PayFrost System will then use Shamir Secret Sharing to generate a brand new encrypted document that is encrypted by this new user-set password. To generate this new encrypted document, PayFrost randomly selects new x-coordinates and applies Shamir Secret Sharing polynomial interpolation to replace the mobile, browser, and server Shamir pieces. The user prints the brand new QR code and stores it in a safe place.

####Shamir Document Redefinition

If a user realizes if any one of their browser password, mobile password, or that one of the two offline QR codes has been stolen by an adversary, and the adversary has not yet stolen the threshold number of pieces to reconstruct the user's symmetric keys, then the user can replace the remaining pieces in the user's possession such that the pieces the adversary has stolen become useless. The adversary would be forced to start all over again to reach the threshold--hereby named Redefinition. In Redefinition the user first logs in and the user selects to perform it. The PayFrost system will proceed to generate new pieces using brand new constants for a_1 and a_2 as defined by the Shamir Polynomial equation (see "Splitting A Symmetric Key Using Shamir Secret Sharing") and by randomly selecting brand new x-coordinates. Even though these changes are made, none of the symmetric keys possessed by the browser, mobile application, nor server are changed. Only the Shamir documents useful for reconstructing them are. The PayFrost system will ask the user to type in their current browser and mobile passwords, or allow the user to set brand new ones if necessary, to re-encrypt the brand new set of Shamir documents. Finally, the PayFrost system allows the user to download the two brand new QR codes that the user must print.

####Shamir Document Symmetric Key Rotation

This is the most expensive operation and is the most unlikely to be necessary. Symmetric key rotation is only necessary if an adversary manages to steal one of the browser, mobile, or server symmetric keys in RAM. Since a server that does not use a hardware security module is at risk of theft of server application symmetric key, it is best if a server is connected to a true hardware security module that is FIPS-140-2 or FIPS-140-3 compliant as soon as possible. In Key Rotation, all three symmetric keys must be replaced. To do this, first all symmetric secrets for all given origins, documents, and payment credentials are decrypted and temporarily stored on the user's browser application. Next, the browser application, mobile application, and server application each independently generate a new symmetric secret. Each application applies Shamir secret sharing to divide their respective symmetric key into five pieces--where three are dispersed across the three applications and two given to the user to be stored offline in the form of two, distinct QR code printed documents (see "Splitting a Symmetric Key using Shamir Secret Sharing" and "Sharing of Shamir Secret Sharing Pieces"). Once these documents are encrypted and stored on the server or printed by the user, the PayFrost proceeds to re-encrypt all symmetric secrets pertaining to all user origins, documents, and payment credentials using the brand new set of browser, mobile, and server symmetric keys.

##Sharing of Secrets in an Organization

In organizations, there is often a bureaucracy where there is an owner of an organization that oversees the activity of everyone else. To help save time, the owner assigns the ability to people who have the role as moderators to oversee the activity of normal users within the organization. The member of a bureaucratic class that is responsible for overseeing the activity of someone in a lower bureaucratic class may override any actions a person in a lower bureaucratic class may perform with or wihout the person's consent. Today, some password managers have been designed to automate this bureaucracy of control of an organization's data with a single click of a button. Our secret management systems allows members of an organization to do this both for sharing secret information, including payment credentials.

###Design of Secret Sharing in an Organization

The owner's master seed is generated using the `randombytes_buf` API function. The 32-byte master seed is then applied to `crypto_box_seed_keypair` to deterministically derive the owner's master private-public keypair. To protect the owner's master seed and private key, each are encrypted first by the owner's browser symmetric key, second by the owner's mobile application symmetric key, and finally by the server application's symmetric key. All public keys, including the owner's, are available to anyone throughout the organization. This allows anyone to send documents with confidentialy and integrity to the person that owns the private key using the person's public key to encrypt the document. This is done using LibSodium's "Sealed Box" API. To add moderators that can overwatch users on the owner's behalf, the owner can take his master seed as the master key, assign a distinct `keyid` and an `appid` to each distinct moderator, and apply these inputs to `crypto_generichash_blake2b_salt_personal` to derive distinct moderator seeds. Each moderator will encrypt their seed the same way the owner does and from it derive their own private-public keypair using `crypto_box_seed_keypair`. Both the keyid and appid of each moderator are stored in plaintext on the server. Thus, the owner can independently derive each and every moderator's seed, allowing them to view and edit all documents each moderator stores in their own account. Yet, no moderator can see each others' documents and cannot see the documents stored on the owner's account. This same strategy applies when a moderator adds distinct users that are meant to be managed by moderators or the owner himself. The moderator that is tasked with managing a new user will take their own master seed, assign a distinct `keyid` and an `appid` to the new user, and from it derive the user's seed. The user will protect their seed the same way owners and moderators protect their seed. Since the user's `keyid` and `appid` are stored in plaintext on the server, both the moderator responsible for managing the user's seed and the owner can each independently derive the user's seed and view and edit all documents the user has access to within the organization. This paragraph demonstrates how an organization with bureaucracy of access can be enforced in our secret management system.

####Sharing of Secrets with All Members in a Bureaucracy Class

Sometimes a person that is responsible for managing all members in an entire bureaucracy class, such as a moderator or owner, may wish to share a document with all the members of the bureaucracy class said person is in charge of overseeing. In the case of the owner this may be sharing only with all the moderators. In the case of a moderator this may be sharing with all the users said moderator is responsible for managing. In each case, the owner and moderator may easily do this by following the following scheme. From the owner or moderator's seed, a seed is derived using a `keyid` of 0 and an `appid` specific to the sharing event. This seed is shared with all members of the bureaucracy class. So when the owner or moderator must share a document with all members in the bureaucracy class, the owner or moderator will encrypt the symmetric key used to encrypt the document with the public subkey derived from the seed shared with the rest of the bureaucracy class. The encrypted document is then sent to all members of the bureaucracy class and are notified to use the shared private subkey to read the contents.

####Backup & Restoration of Seeds

In real life, people are managed by others in a bureaucracy. Therefore, certain data may become accessible if a manager abruptly leaves the organization. In the bureaucracy system mentioned in this whitepaper, such managers may be an owner or a moderator. A simple way to ensure easy replacement of either is to use Shamir Secret Sharing to split the owner or moderator's master seed into a number of pieces, say five and at least three may  be required to reconstruct the owner seed. Members of the organization that have proven to be responsible with managing their online security--especially with Shamir Secret Sharing--should each be given one piece. Each member's account will accept their single piece and split it amongst the documents that are managed by their browser, mobile, and server applications (see "Splitting a Symmetric Key using Shamir Secret Sharing" and "Sharing of Shamir Secret Sharing Pieces"). This way, each person trusted with a piece protects their piece seamlessly with their account under the PayFrost system. When the previous owner leaves the organization and fails to responsibly pass the master seed to the new owner, at least three out of five people in the organization entrusted with one piece should reach a consensus on who the new owner should be. Once this is done, each of the pieceholders will first log in to their account and securely send their piece to the new owner. This is securely sent to the new owner using LibSodium's "Sealed Box" API. Once the new owner receives all the pieces, the new owner applies the reconstruction algorithm used in Shamir Secret Sharing to reconstruct the original owner seed. From that point on, the new owner is ready to take over the role of ownership of the organization.

In the above scheme, the importance of splitting the original seed into multiple pieces and entrusting only one piece with each pieceholder is to spread the risk of protecting the seed. It is also makes it unfeasible for an adversary to steal enough pieces to reconstruct the original owner seed. To further increase the difficulty of reconstruction against an adversary, the threshold number of pieces required may be increased relative to the total number of pieces used to split the owner seed. It is strongly recommended that this ratio conform to the equation `n = 2k - 1`, where `n` is the total number of pieces the owner seed was dispersed across and `k` is the threshold number of pieces required to reconstruct the owner seed. It makes for a robust system resistant against both loss and theft of pieces. 

###Collaborative Online Editing of Documents

Another selling point of a digital, centralized storage system is that it allows for online collaborative editing of documents. In the PayFrost system, a manager--whether that be an owner or a moderator--may publish a document to other personnel in an organization. The owner or moderator allows other personnel to make edit suggestions and the owner or moderator decides which edit suggestions are accepted. The PayFrost system will use the `git` tool to keep track of the reversion of such documents. An edit meant to be shared with the rest of the collaboration team may update the edit suggestions using a shared public key to safely store the suggestions on the PayFrost server. To send an edit suggestion directly to another collaborator, the person may encrypt the edit suggestion using the recipient's public key instead. Once a manager approves of the edit suggestions, the manager may save the changes to the document. To ensure the update is clearly official by the manager, there should be two reversion copies of the document in-progress. On reversion copy is encrypted by the manager directly using a password only the manager has access to. Another copy is shared amongst the collaboration team and it is this copy where live edit suggestions are visible, when legal, amongst team members. Whenever the manager updates the reversion copy only the manager knows the password to, the same updates are made official on the reversion copy the rest of the collaboration team has access to. Any suggested edits that were not saved as official on the manager-reserved copy disappear. In case, the manager made a mistake, the manager can revert back to a version of the reserved-copy that had the edit suggestions that were mistakenly omitted.

####Saving Money When Managing Payments

The PayFrost system is designed to make it easier for managers to manage who earns and spends how much, where, when, and with which currency--be it a fiat currency or even cryptocurrency. Consider a traditional family. In a traditional family, there are often two parents and two children. For this example, consider the scenario where one parent has access to a bank account and both children are completely and financially dependent on said parent. Unsurprisingly, the children routinely asks the parent with a bank account for financial favors. At the time of this writing, there are generally four established methods of payment: Automated Clearing House Payment, a debit or credit card, a gift card specific to the merchant, or cryptocurrency such as Bitcoin. 

The parent does not feel comfortable disclosing his bank routing and account numbers to his children. They could cause the parent to lose money in a reckless accident. The parent knows its honestly no safer entrusting the parent's actual debit card with his children for the same reason. Not only can the children get away with buying something without the parent's approval ( a case of chargeback fraud), but the children's online accounts may get compromised. This would allow an adversary to steal the parent's debit card credentials. The parent cannot ask for more than one debit card per checking account. To circumvent this, the parent subscribes to our virtualized debit card service. Like other virtualized debit card services, this allows the parent to generate a new virtualized debit card with its own unique card number, CVC code, and expiration date. Like others, our virtualized debit card service allows the parent to set rate limits on which online websites or merchants, how frequently, how much and sometimes until what deadline someone may charge with the card. THis gives the parent the reassurance that the children cannot misbehave with the card. Like others, a problem with our virtualized debit card service is that charging debit and credit cards is that fees are often ~1.55%. This matters to the parent since he typically has to pay $10-$15 USD per month for the right to use a typical virtualized debit card service. At PayFrost we use the VISA API system to generate virtualized debit cards, so solely relying on our service alone will honestly cost just as much.

Unlike other payment managers, PayFrost offers a system to help the parent save money. Not only does PayFrost offer a virtualized debit card service, it also allows the parent to instead give a gift card to the child or even send cryptocurrency to the child in case the child wishes to subscribe to a service that accepts cryptocurrency as payment. This matters since transaction fees using blockchain technology can be substantially cheaper than debit or credit card fees. PayFrost has struck a deal with a company that allows merchants to send gift cards to their customers after paying with Bitcoin on the Bitcoin Lightning Network. Since the average transaction fee on the Bitcoin Lightning Network is extremely low, PayFrost only charges a 0.1% transaction per gift card the parent has to deliver to one of his children. Whenever the parent uses this option, PayFrost will charge the parent's bank account and collect payment using Automated Clearing House (ACH), which costs nothing to cause bank transfer but takes days to settle to PayFrost's business bank account. However, PayFrost does not wait for the ACH payment to settle and instead immediately delivers the final gift card to the parent to disperse to the parent's children. The same 0.1% transaction fee is charged whenver the parent realizes the online service one of the children want to use accepts cryptocurrency--and is even more convenient since PayFrost will simply send the cryptocurrency payment instantly to the merchant, collecting payment from parent through ACH later.

In one month, the parent spends $659.45 for the sake of the children altogether. Assuming the parent solely did these through PayFrost's virtualized debit card service, this would have been $659.45 * 1.0155 = $10.23 for that month. This is within the expected $10-15 per month for the typical virtualized debit card service.

What the parent instead could have done is first carefully determine which payment methods the online service the child is asking for accepts. Usually, the merchant does not accept cryptocurrency. Instead, the merchant accepts a debit or credit card--or a gift card. So instead of authorizing a transaction through virtualized debit card, the parent instead assigns a new gift card to cover the cost of the online subscription every month. The parent takes a look back at how many transactions could have been made using gift cards or even cryptocurrency instead. The parent realizes that out of the $659.45 spent for that month, only $96.04 USD actually had to be made using virtualized debit cards since there was no other accepted payment alternative! In real life, most established services have a gift card system, and the business PayFrost struck a business deal with has gift cards for almost all of those established services. The parent takes a look at the other $563.41 that could have been spent using gift cards (purchased on behalf of parent using the Bitcoin Lightning Network) or by spending Bitcoin on the Lightning Network directly. Since the transaction fee in the previous two cases is 0.1% as charged by PayFrost, the parent realizes the net amount of transaction fees paid from the $563.41 would be $0.57 USD for that month. Combining the hypothetical net $0.57 USD transaction fee with the net amount of transaction fees from the $96.04 USD in using the virtualized debit card service, the net amount of transaction fees could have been ~$2.06 USD instead of $10.22 USD. So unlike other virtualized payment managers, PayFrost's payment management system will deliberately charge per transaction instead of a monthly subscription to help users save as much money as possible when making a transaction. Organizations other than families can easily benefit from the PayFrost payment management system model for the same reason.

###Sharing of Payment Credentials

Sharing such payment credentials as described previously requires care. To help owners and moderators manage this, payment managers including virtualized debit card services have introduced rate limits. However, such services often lack a role-based access feature where such payment credentials can feasibly be shared amongst people that are managed by others. This is a useful case where a manager can rate-limit in which cases a subordinate may make payments, where, and at what times. PayFrost's Secret Management Service is capable of auto-generating new virtualized debit cards, gift cards, and the sending of cryptocurrency to destination wallets for this purpose.

####Enforcing Role-Based Access for Payment Credentials

Consider the parent that wishes to grant access to a $10/month max-limit virtualized card to one of his children. The account number, CVC code, expiration date, name of merchant, and rate-limit information are all stored in a document. The manager asks PayFrost to securely send this document to the subordinate. The PayFrost system automatically queries the public subkey of the subordinate, securely generates a random 256-bit symmetric key using LibSodium's `randombytes_buf`, and uses this as the symmetric key to first encrypt the document. PayFrost encrypts this symmetric secret with the subordinate's public key using LibSodium's "Sealed Box" API, allowing both the manager and the subordinate to view the contents of the decrypted document (the manager has the ability to derive the subordinate's public key at all times). Next, the PayFrost system will generate a second, distinct symmetric secret using `randombytes_buf` and applies this seconnd symmetric secret and the entire encrypted document to HMAC-BLAKE2b using LibSodium's `crypto_generichash` API function. The second symmetric secret is encrypted with the manager's public key. The output HMAC is stored on the server. If at any point an adversary manages to compromise's PayFrost's servers and tampers with the encrypted document in any sense of the word, the manager will be able to tell this took place since the symmetric secret and encrypted document failed to output the same HMAC output. To ensure the integrity and authenticy of the HMAC output itself, the HMAC output may itself be applied to three distinct HMAC instances, one for each of the browser, mobile, and server application symmetric keys. Since the manager is in-session on the PayFrost system, this is done automatically. If the manager wishes, they may wish to enforce a browser and mobile passwords re-prompt, where the Argon2ID password hash and then HKDF output is used as the symmetric key in the final, distinct HMAC output.

##AutoPayments

Autopayments are a major convenience of digital online fintech services. It is easy for a manager to control autopayments in the case of virtualized debit cards and gift cards. In the case of virtualized debit cards, the charge attempted will not be authorized beyond the limit set by the manager. In the case of gift cards, a new gift card may be sent before each recurring payment deadline and applied to the account to cover payment. The case of autopayments for cryptocurrency is not established yet, although it can be. Today, merchants are increasingly accepting Bitcoin as payment but whenever users wish to make payments with cryptocurrency, such users are forced to conduct each recurring payment manually even if the same merchant accepts autopayments using other conventional methods. To perform autopayments in cryptocurrency properly, the merchant must first have a registered business account under the PayFrost system (free to register). After PayFrost approves of the business partnership, PayFrost will establish a Bitcoin payment channel route to the merchant's Lightning node. The merchant may then apply simple-to-use web-developer APIs that guide the user into setting up autopayments. When the user subscribes under the autopayment feature, they are charged the standard 0.1% transaction fee for conducting a Bitcoin Lightning Network payment under the PayFrost system. The main benefit of Bitcoin to the merchant are lower transaction fees and faster arrival of payment compared to conventional methods, especially when using the Bitcoin Lightning Network.

###Design of Cryptocurrency Autopayments

Gresham's Law states the less valuable money in circulation will drive the more valuable money in society's sight out of circulation. It is thus no surprise that people who spend Bitcoin first convert a portion of their paycheck to cryptocurrency and then spend the Bitcoin. Not the other way around. PayFrost will follow this model. Except for autopayments a few rules must be followed. After the user registers their bank account and routing numbers on our service, the customer is free to subscribe to an online service that has a registered merchant account with PayFrost. While using the autopayment setup portal the customer selects an online service, the recurring payment amount, and the frequency at which payment may be accepted. Traditionally, each Bitcoin payment method is presented as a Lightning invoice whenever a customer makes a manual payment through Bitcoin Lightning. Instead of requiring the customer to manually copy and paste this to send payment before every recurring payment deadline, PayFrost's servers will securely retrieve the Bitcoin Lightning Invoice for next payment period securely from the merchant's servers using mutual TLS Authentication. Once the currentmost Bitcoin Lightning Invoice is retrieved, PayFrost will charge the customer's bank account through Automated Clearing House and send the Bitcoin payment to the merchant through the Lightning Network. 

###Refunds

Earning back refunds in cryptocurrency is not as intuitive as it is under conventional payment methods--even virtualized debit card services. The situation is much more difficult when using the Bitcoin Lightning Network as there is no obvious sending or receiving address as there is on the traditional Blockchain. Many users think simply having access to any cryptocurrency wallet from any online service suffices to gurantee refunds. In the real world this is not the case. Many cryptocurrency providers that have received negative reviews for failing to receive refunds are often misplaced. It was not that the cryptocurrency provider did not try to give a refund. It was that the customer *rented* an address from the online cryptocurrency wallet service said customer had access to. Since the customer does not have true control of the actual Full Node that verifies payments on the online cryptocurrency wallet service, the customer does not get to change the length of time said customer is able to send and *receive* payments to the last address the customer spent with. Everyday, real-life cryptocurrency spenders lose money due to misunderstandings such as these.

To prevent this from being an issue, each and every PayFrost user will be assigned their own dedicated master private key for the purpose of receiving refunds. Wheras PayFrost can send payments from its own reserves, it is better if the customer is able to receive their refund directly under a master private key only the customer has knowledge. However, this is certainly not best. In order for a customer to actually send and receive Bitcoin on the blockchain, the customer's wallet must be connected to a valid Bitcoin full node. It is cheap and affordable to purchase the hardware to store the blockchain, but it is expensive and time-consuming to host servers that are accessible on the World Wide Web. Although a user can technically connect to PayFrost's full node, it is best if every PayFrost customer has the option to remotely connect to their own full node inexpensively with the help of our PayFrost server system.  This gives customers the flexibility to define their own policies on how refunds are received. PayFrost will allow customers to register their local Bitcoin full node on the PayFrost server system by registering an mTLS private-public keypair for the customer. PayFrost will provide a software package that allows the customer's full node local computer to asynchronously communicate with the PayFrost server system to receive Remote Procedure Calls made by the customer. All information that must be routed from customer browser appliccation, through PayFrost's servers, and to the customer's actual full node are protected by mutual TLS encryption. The information for the Remote Procedure Calls are decrypted by the customer's full node computer and processed directly on the customer's full node computer.

###Refund Policy

Not being able to perform chargebacks with cryptocurrency is a mixed blessing. It helps merchants save money yet leaves customers vulnerable to a potential scam. In the past, escrow services have been proposed that store the cryptocurrency in a multisig wallet. A common robust escrow service is a 2-out-of-3 multisig operation. In such a scheme, at least two-out-of-three of the customer, seller, and escrow service must cosign a transaction from the multisig wallet to the destination. A major problem with this design is how costly it is to cosign a multisignature transaction. A single standard Bitcoin on-chain transaction has transaction fees that are slightly less than the standard debit card or credit card fee. Asking customers to cosign a multisig transaction will more often than not make the transaction fee higher than the standard debit card or credit card fee, often nearly twice as much as the transaction would have been had the transaction required only a single signature.

Instead of relying on an escrow design, it is best if both customer and merchant agree upon a refund policy, and the PayFrost service bears witness to the event. The customer sends their cryptocurrency to the merchant's wallet. If, at any time, the customer requests a refund and the merchant fails to comply, PayFrost will ban the merchant from conducting business with PayFrost completely and even take legal action if necessary. PayFrost can easily trace where the merchant sent the cryptocurrency using blockchain OSINT technologies. This simple legal practice suffices to ensure the merchant behaves. An escrow system would place a transaction fee cost higher than conventional methods. If the customer is adamant on being able to file a chargeback claim in case the transaction turns out to be fraudulent or suspects the merchant is not trustworthy, it is best if the customer pays with a virtualized debit card instead of cryptocurrency. PayFrost, like other virtualized debit card services, is capable of processing chargebacks the same way it is done for normal debit or credit cards. That, and charging on a virtualized debit card is on average cheaper than the standard cryptocurrency multisig operation that would achieve the same effect as a chargeback in a conventional payment card system.


###Cryptocurrency Insurance System

The PayFrost secret management system is designed to be a robust, fault-tolerant system to store secrets of all kinds--including cryptocurrency master private keys. Since the PayFrost secret management system is designed to withstand up to two points of failure in a Shamir Secret Sharing Scheme of three-out-of-five, it is unlikely that the customer will lose too many pieces to recover their account or that an adversary will successfuly steal at least three pieces to steal the user's cryptocurrency funds. Even then, a major disadvantage of cryptocurrency is a lack of an insurance system. This is especially important if the customer wishes to pass on their cryptocurrency funds to their inheritors in a safe manner. The PayFrost system will offer a low cost insurance premium transaction fee of 0.3% that will grant PayFrost enough funds to cover for insurance in the event of the death of a PayFrost customer that has registered for PayFrost's insurance plan. As the customer demonstrates responsibility over managing their assets, PayFrost will give chargeback small fractions of the insurance premium back to the customer.

Such a customer should ideally share the two offline pieces with their family members, leaving the recovery password a secret known only to the customer. In the event the customer passes away, the family members must get into a video call with PayFrost, prove their identity by showing their federal government approved ID and their real face during the video call. This will help resolve any court disputes on inheritance. PayFrost will verify the death certificate of the individual and once this verification completes will extract the customer's piece stored in plaintext on PayFrost's server and send it to the family member. Since the family member now has access to three pieces, the family will be able to decrypt the deceased customer's vault and pass on the deceased customer's funds to the inheritors.

